CREATE table CUSTOMER (
    NAME        VARCHAR(99) NOT NULL PRIMARY KEY
);

CREATE table ADDRESS (
    CNAME       VARCHAR(99) NOT NULL,
    LINE1       VARCHAR(99),
    LINE2       VARCHAR(99),
    CITY        VARCHAR(99),
    STATE       VARCHAR(99),
    SUBURB_CODE VARCHAR(9),
    COUNTRY     VARCHAR(50),
    TELEPHONE   VARCHAR(20),
    EMAIL       VARCHAR(99),
    PRIMARY KEY(CNAME, LINE1),
    FOREIGN KEY(CNAME) REFERENCES CUSTOMER(NAME)
);

CREATE table ACCOUNT (
    ACCNUM      INTEGER NOT NULL PRIMARY KEY,
    CNAME       VARCHAR(99),
    ALINE1      VARCHAR(99),
    DISCOUNT    DECIMAL(2),
    RATING      CHAR(1),
    BALANCE     DECIMAL(9,2),
    FOREIGN KEY(CNAME) REFERENCES CUSTOMER(NAME),
    FOREIGN KEY(CNAME, ALINE1) REFERENCES ADDRESS(CNAME, LINE1)
);

CREATE table SERVICE (
    SVCNO       VARCHAR(20) NOT NULL PRIMARY KEY,
    ACCNUM      INTEGER,
    STYPE       CHAR(1),
    RATE        DECIMAL(2),
    FOREIGN KEY(ACCNUM) REFERENCES ACCOUNT(ACCNUM)
);

CREATE table PAYMENT (
    UID         INTEGER NOT NULL 
                PRIMARY KEY GENERATED ALWAYS AS IDENTITY 
                (START WITH 1, INCREMENT BY 1),
    ACCNUM      INTEGER,
    AMOUNT      DECIMAL(9,2),
    PAID_ON     DATE,
    FOREIGN KEY(ACCNUM) REFERENCES ACCOUNT(ACCNUM)
);
