package TelcoClient;

import TelcoEntity.Customer;
import TelcoSession.CustomerFacadeRemote;
import javax.ejb.*;
import javax.naming.*;

public class CustomerClient
{
  public static void main(String[] args) throws Exception
  {
    Context ic = new InitialContext();
    Object obj = ic.lookup(CustomerFacadeRemote.class.getName());
    System.out.println("lookup returned " + obj);
    CustomerFacadeRemote customerFacade = (CustomerFacadeRemote) obj;

    if      (args.length == 0 || args[0].equals("find"))
    {
      String name = (args.length > 1) ? args[1] : "Ab Initio";

      Customer customer = customerFacade.find(name);

      if (customer == null)
      {
        System.out.println("customer " + name + " not found");
      }
      else
      {
        System.out.println("customer " + name +
                           " has name '" + customer.getName() + "'");
      }
    }
    else if (args[0].equals("create"))
    {
      if (args.length < 2)
      {
        System.out.println("You need to specify a name when creating!");
      }
      else
      {
        Customer customer = new Customer();
        customer.setName(args[1]);
        customerFacade.create(customer);

        System.out.println("created customer:" +
                           " name ='" + customer.getName() + "'");
      }
    }
  }
}
